#ifndef EFL_GENERATED_EDJE_EDIT_HH
#define EFL_GENERATED_EDJE_EDIT_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "edje_edit.eo.h"
}

#include "edje_object.eo.hh"

namespace edje {

struct edit;

}

namespace eo_cxx {

namespace edje {

struct edit
{

   static Eo_Class const* _eo_class()
   {
      return(EDJE_EDIT_CLASS);
   }

   operator ::edje::edit() const;
   operator ::edje::edit&();
   operator ::edje::edit const&() const;

   template <typename D>
   struct address_of
   {
      operator ::edje::edit*() const { return static_cast<::edje::edit*>(static_cast<D const*>(this)->p); }
      operator ::edje::edit const*() const { return static_cast<::edje::edit const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::edje::edit const*() const { return static_cast<::edje::edit const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}

namespace edje {

struct edit
      : ::efl::eo::concrete
      , ::eo_cxx::edje::object
      , ::eo_cxx::efl::file
      , ::eo_cxx::eo::base
      , ::eo_cxx::evas::common_interface
      , ::eo_cxx::evas::object
      , ::eo_cxx::evas::object_smart
      , ::eo_cxx::evas::signal_interface
      , ::eo_cxx::evas::smart_clipped
{
   edit(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : edit(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit edit(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit edit(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   edit(edit const& other)
      : edit(eo_ref(other._eo_ptr()))
   {}

   ~edit() {}


   static Eo_Class const* _eo_class()
   {
      return(EDJE_EDIT_CLASS);
   }

   struct address_of
      : ::eo_cxx::edje::edit::address_of<address_of>
      , ::eo_cxx::edje::object::address_of<address_of>
      , ::eo_cxx::efl::file::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::eo_cxx::evas::common_interface::address_of<address_of>
      , ::eo_cxx::evas::object::address_of<address_of>
      , ::eo_cxx::evas::object_smart::address_of<address_of>
      , ::eo_cxx::evas::signal_interface::address_of<address_of>
      , ::eo_cxx::evas::smart_clipped::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::edje::edit* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::edje::edit::address_const_of<address_const_of>
      , ::eo_cxx::edje::object::address_const_of<address_const_of>
      , ::eo_cxx::efl::file::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::eo_cxx::evas::common_interface::address_const_of<address_const_of>
      , ::eo_cxx::evas::object::address_const_of<address_const_of>
      , ::eo_cxx::evas::object_smart::address_const_of<address_const_of>
      , ::eo_cxx::evas::signal_interface::address_const_of<address_const_of>
      , ::eo_cxx::evas::smart_clipped::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::edje::edit const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EDJE_EDIT_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::edje::edit) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::edje::edit>::value, "");

}

inline ::eo_cxx::edje::edit::operator ::edje::edit() const
{
   return *static_cast<::edje::edit const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::edje::edit::operator ::edje::edit&()
{
   return *static_cast<::edje::edit*>(static_cast<void*>(this));
}

inline ::eo_cxx::edje::edit::operator ::edje::edit const&() const
{
   return *static_cast<::edje::edit const*>(static_cast<void const*>(this));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::edje::edit >
{
   template <typename T>
   struct type
         : virtual operations< ::edje::object >::template type<T>
   {
   };
};


template<>
struct operation_description_class_size< ::edje::edit >
{
   static const int value = 0 + operation_description_class_size<::edje::object >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::edje::edit>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   initialize_operation_description<T>(::efl::eo::detail::tag<::edje::object>(), &ops[0]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::edje::edit >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::edje::edit, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::edje::edit>)
{
   return (EDJE_EDIT_CLASS);
}

} } }
#endif // EFL_GENERATED_EDJE_EDIT_HH

